unit UConnectMdl;

interface

uses
  System.SysUtils, System.Classes, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.FB,
  FireDAC.Phys.FBDef, FireDAC.Stan.Param, FireDAC.DatS, FireDAC.DApt.Intf,
  FireDAC.DApt, FireDAC.VCLUI.Wait, Data.DB, FireDAC.Stan.StorageBin,
  FireDAC.Stan.StorageJSON, FireDAC.Comp.UI, FireDAC.Phys.IBBase,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client;

type
  TConnectMdl = class(TDataModule)
    dbDB: TFDConnection;
    qDataBase: TFDQuery;
    FDPhysFBDriverLink1: TFDPhysFBDriverLink;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDStanStorageJSONLink1: TFDStanStorageJSONLink;
    FDStanStorageBinLink1: TFDStanStorageBinLink;
    dsoDataBase: TDataSource;
    qDataBaseMONDATABASE_NAME: TWideStringField;
    qDataBaseMONPAGE_SIZE: TSmallintField;
    qDataBaseMONODS_MAJOR: TSmallintField;
    qDataBaseMONODS_MINOR: TSmallintField;
    qDataBaseMONOLDEST_TRANSACTION: TIntegerField;
    qDataBaseMONOLDEST_ACTIVE: TIntegerField;
    qDataBaseMONOLDEST_SNAPSHOT: TIntegerField;
    qDataBaseMONNEXT_TRANSACTION: TIntegerField;
    qDataBaseMONPAGE_BUFFERS: TIntegerField;
    qDataBaseMONSQL_DIALECT: TSmallintField;
    qDataBaseMONSHUTDOWN_MODE: TSmallintField;
    qDataBaseMONSWEEP_INTERVAL: TIntegerField;
    qDataBaseMONREAD_ONLY: TSmallintField;
    qDataBaseMONFORCED_WRITES: TSmallintField;
    qDataBaseMONRESERVE_SPACE: TSmallintField;
    qDataBaseMONCREATION_DATE: TSQLTimeStampField;
    qDataBaseMONPAGES: TLargeintField;
    qDataBaseMONSTAT_ID: TIntegerField;
    qDataBaseMONBACKUP_STATE: TSmallintField;
    qDataBaseSHUTDOWN_MODE: TWideStringField;
    qDataBaseBACKUP_STATE: TWideStringField;
    qAttach: TFDQuery;
    dsoAttach: TDataSource;
    qAttachMONATTACHMENT_ID: TIntegerField;
    qAttachMONSERVER_PID: TIntegerField;
    qAttachMONSTATE: TSmallintField;
    qAttachMONATTACHMENT_NAME: TWideStringField;
    qAttachMONUSER: TWideStringField;
    qAttachMONROLE: TWideStringField;
    qAttachMONREMOTE_PROTOCOL: TStringField;
    qAttachMONREMOTE_ADDRESS: TStringField;
    qAttachMONREMOTE_PID: TIntegerField;
    qAttachMONCHARACTER_SET_ID: TSmallintField;
    qAttachMONTIMESTAMP: TSQLTimeStampField;
    qAttachMONGARBAGE_COLLECTION: TSmallintField;
    qAttachMONREMOTE_PROCESS: TWideStringField;
    qAttachMONSTAT_ID: TIntegerField;
    qAttachSTATE: TWideStringField;
    qAttachCHARSET: TWideStringField;
    qStatem: TFDQuery;
    dsoStatem: TDataSource;
    qStatemMONSTATEMENT_ID: TIntegerField;
    qStatemMONATTACHMENT_ID: TIntegerField;
    qStatemMONTRANSACTION_ID: TIntegerField;
    qStatemMONSTATE: TSmallintField;
    qStatemMONTIMESTAMP: TSQLTimeStampField;
    qStatemMONSQL_TEXT: TMemoField;
    qStatemMONSTAT_ID: TIntegerField;
    qStatemSTATE: TWideStringField;
    qStatemSQL: TStringField;
    qTrans: TFDQuery;
    dsoTrans: TDataSource;
    qTransMONTRANSACTION_ID: TIntegerField;
    qTransMONATTACHMENT_ID: TIntegerField;
    qTransMONSTATE: TSmallintField;
    qTransMONTIMESTAMP: TSQLTimeStampField;
    qTransMONTOP_TRANSACTION: TIntegerField;
    qTransMONOLDEST_TRANSACTION: TIntegerField;
    qTransMONOLDEST_ACTIVE: TIntegerField;
    qTransMONISOLATION_MODE: TSmallintField;
    qTransMONLOCK_TIMEOUT: TSmallintField;
    qTransMONREAD_ONLY: TSmallintField;
    qTransMONAUTO_COMMIT: TSmallintField;
    qTransMONAUTO_UNDO: TSmallintField;
    qTransMONSTAT_ID: TIntegerField;
    qTransSTATE: TWideStringField;
    qTransISOLATIONMODE: TWideStringField;
    qIoStats: TFDQuery;
    dsoIoStats: TDataSource;
    qMemory: TFDQuery;
    dsoMemory: TDataSource;
    qRecord: TFDQuery;
    dsoRecord: TDataSource;
    qIoStatsMONSTAT_ID: TIntegerField;
    qIoStatsMONSTAT_GROUP: TSmallintField;
    qIoStatsMONPAGE_READS: TLargeintField;
    qIoStatsMONPAGE_WRITES: TLargeintField;
    qIoStatsMONPAGE_FETCHES: TLargeintField;
    qIoStatsMONPAGE_MARKS: TLargeintField;
    qIoStatsSTAT_GROUP: TWideStringField;
    qMemoryMONSTAT_ID: TIntegerField;
    qMemoryMONSTAT_GROUP: TSmallintField;
    qMemoryMONMEMORY_USED: TLargeintField;
    qMemoryMONMEMORY_ALLOCATED: TLargeintField;
    qMemoryMONMAX_MEMORY_USED: TLargeintField;
    qMemoryMONMAX_MEMORY_ALLOCATED: TLargeintField;
    qMemorySTAT_GROUP: TWideStringField;
    qRecordMONSTAT_ID: TIntegerField;
    qRecordMONSTAT_GROUP: TSmallintField;
    qRecordMONRECORD_SEQ_READS: TLargeintField;
    qRecordMONRECORD_IDX_READS: TLargeintField;
    qRecordMONRECORD_INSERTS: TLargeintField;
    qRecordMONRECORD_UPDATES: TLargeintField;
    qRecordMONRECORD_DELETES: TLargeintField;
    qRecordMONRECORD_BACKOUTS: TLargeintField;
    qRecordMONRECORD_PURGES: TLargeintField;
    qRecordMONRECORD_EXPUNGES: TLargeintField;
    qRecordSTAT_GROUP: TWideStringField;
    procedure qStatemCalcFields(DataSet: TDataSet);
  private
    FAttachm: Integer;
    FOnlyActiveAtt: Boolean;
    FOnlyActiveStatem: Boolean;
    FTransac: Integer;
    FStatId: Integer;
    procedure SetOnlyActiveAtt(const Value: Boolean);
    procedure SetAttachm(const Value: Integer);
    procedure SetOnlyActiveStatem(const Value: Boolean);
    procedure SetTransac(const Value: Integer);
    procedure SetStatId(const Value: Integer);

    procedure FilterStatements;
  public
    procedure Connect(ServerIP, DataBase, UserName, Pass: string);
    procedure Disconnect;

    procedure RefreshInfo;

    property OnlyActiveAtt: Boolean read FOnlyActiveAtt write SetOnlyActiveAtt;
    property OnlyActiveStatem: Boolean read FOnlyActiveStatem write SetOnlyActiveStatem;
    property Attachm: Integer read FAttachm write SetAttachm;
    property Transac: Integer read FTransac write SetTransac;
    property StatId: Integer read FStatId write SetStatId;
  end;

var
  ConnectMdl: TConnectMdl;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TConnectMdl }

procedure TConnectMdl.Connect(ServerIP, DataBase, UserName, Pass: string);
begin
  if dbDB.Connected then
    dbDB.Connected := False;

  with dbDB.Params as TFDPhysFBConnectionDefParams do
  begin
    Database := DataBase;
    if SameText(ServerIP, 'localhost') then
      ServerIP := '127.0.0.1';
    Server := ServerIP;
    UserName := UserName;
    Password := Pass;
  end;

  dbDB.Open;

  RefreshInfo;
end;

procedure TConnectMdl.Disconnect;
begin
  if dbDB.InTransaction then dbDB.Rollback;

  if dbDB.Connected then
    dbDB.Connected := False;
end;

procedure TConnectMdl.FilterStatements;
begin
  qStatem.Filtered := False;
  if FOnlyActiveStatem and (FAttachm <> -1) then
    qStatem.Filter := 'mon$state = 1 and MON$ATTACHMENT_ID = ' + IntToStr(FAttachm)
  else
    if FOnlyActiveStatem and (FAttachm = -1) then
      qStatem.Filter := 'mon$state = 1'
    else
      if not FOnlyActiveStatem and (FAttachm <> -1) then
        qStatem.Filter := 'MON$ATTACHMENT_ID = ' + IntToStr(FAttachm)
      else
        qStatem.Filter := '';
  qStatem.Filtered := qStatem.Filter <> '';
end;

procedure TConnectMdl.qStatemCalcFields(DataSet: TDataSet);
var S: string;
begin
  S := DataSet.FieldByName('MON$SQL_TEXT').AsString;
  if Length(S) > 1490 then
    S := Copy(S, 1, 1490) + '[...]';
  DataSet.FieldByName('SQL').AsString := S;
end;

procedure TConnectMdl.RefreshInfo;
begin
  if dbDB.InTransaction then dbDB.Rollback;

  if not qDataBase.Active then qDataBase.Open
  else qDataBase.Refresh;

  if not qAttach.Active then qAttach.Open
  else qAttach.Refresh;

  if not qStatem.Active then qStatem.Open
  else qStatem.Refresh;

  if not qTrans.Active then qTrans.Open
  else qTrans.Refresh;

  if not qIoStats.Active then qIoStats.Open
  else qIoStats.Refresh;

  if not qMemory.Active then qMemory.Open
  else qMemory.Refresh;

  if not qRecord.Active then qRecord.Open
  else qRecord.Refresh;
end;

procedure TConnectMdl.SetAttachm(const Value: Integer);
begin
  FAttachm := Value;
  FilterStatements;
end;

procedure TConnectMdl.SetOnlyActiveAtt(const Value: Boolean);
begin
  FOnlyActiveAtt := Value;
  qAttach.Filtered := FOnlyActiveAtt;
end;

procedure TConnectMdl.SetOnlyActiveStatem(const Value: Boolean);
begin
  FOnlyActiveStatem := Value;
  FilterStatements;
end;

procedure TConnectMdl.SetStatId(const Value: Integer);
begin
  FStatId := Value;

  qIoStats.Filtered := False;
  if Value <> -1 then
  begin
    qIoStats.Filter := 'MON$STAT_ID = ' + IntToStr(FStatId);
    qIoStats.Filtered := True;
  end;

  qMemory.Filtered := False;
  if Value <> -1 then
  begin
    qMemory.Filter := 'MON$STAT_ID = ' + IntToStr(FStatId);
    qMemory.Filtered := True;
  end;

  qRecord.Filtered := False;
  if Value <> -1 then
  begin
    qRecord.Filter := 'MON$STAT_ID = ' + IntToStr(FStatId);
    qRecord.Filtered := True;
  end;
end;

procedure TConnectMdl.SetTransac(const Value: Integer);
begin
  FTransac := Value;

  qTrans.Filtered := False;
  if Value = -1 then Exit;
  qTrans.Filter := 'MON$ATTACHMENT_ID = ' + IntToStr(FTransac);
  qTrans.Filtered := True;
end;

end.
