unit UMainFrm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.Mask,
  Vcl.DBCtrls, Vcl.Grids, Vcl.DBGrids, Vcl.ExtCtrls, Data.DB;

type
  TMainFrm = class(TForm)
    pcPages: TPageControl;
    tsGeneral: TTabSheet;
    tsAttachments: TTabSheet;
    Label1: TLabel;
    eDataBase: TEdit;
    l1: TLabel;
    eUser: TEdit;
    l2: TLabel;
    ePass: TEdit;
    Label2: TLabel;
    eServer: TEdit;
    bConnect: TButton;
    bRefresh: TButton;
    Label3: TLabel;
    eDatabaseName: TDBEdit;
    Label4: TLabel;
    ePageSize: TDBEdit;
    Label5: TLabel;
    eODSMajor: TDBEdit;
    Label6: TLabel;
    eODSMinor: TDBEdit;
    Label7: TLabel;
    eOldestTrans: TDBEdit;
    Label8: TLabel;
    eOldestActive: TDBEdit;
    Label9: TLabel;
    eOldestSnap: TDBEdit;
    Label10: TLabel;
    eNextTrans: TDBEdit;
    l3: TLabel;
    eSQLDialect: TDBEdit;
    Label11: TLabel;
    eShutdownMode: TDBEdit;
    lTypeName: TDBText;
    lBackupState: TDBText;
    eBackupState: TDBEdit;
    Label12: TLabel;
    Label13: TLabel;
    ePageBuffers: TDBEdit;
    Label14: TLabel;
    eSweepInterval: TDBEdit;
    Label15: TLabel;
    ePages: TDBEdit;
    cbReadOnly: TDBCheckBox;
    cbForcedWrites: TDBCheckBox;
    cbReserveSpace: TDBCheckBox;
    Label16: TLabel;
    eCreationDate: TDBEdit;
    nvAttachments: TDBNavigator;
    gAttachments: TDBGrid;
    cbOnlyActiveAtt: TCheckBox;
    tsStatements: TTabSheet;
    bShowStatements: TButton;
    nvStat: TDBNavigator;
    gStat: TDBGrid;
    cbOnlyActiveSta: TCheckBox;
    Label17: TLabel;
    eAttachId: TEdit;
    tsTransac: TTabSheet;
    nvTransac: TDBNavigator;
    gTransac: TDBGrid;
    bShowTransac: TButton;
    bAttachSta: TButton;
    eAttachIdT: TEdit;
    Label18: TLabel;
    tsStats: TTabSheet;
    bAttachTrans: TButton;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Splitter2: TSplitter;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    DBNavigator3: TDBNavigator;
    Label19: TLabel;
    eStatId: TEdit;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBGrid3: TDBGrid;
    bStatA: TButton;
    bStatT: TButton;
    bStatS: TButton;
    procedure bConnectClick(Sender: TObject);
    procedure bRefreshClick(Sender: TObject);
    procedure cbOnlyActiveAttClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bShowStatementsClick(Sender: TObject);
    procedure eAttachIdChange(Sender: TObject);
    procedure cbOnlyActiveStaClick(Sender: TObject);
    procedure gStatMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure gAttachmentsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bAttachStaClick(Sender: TObject);
    procedure bShowTransacClick(Sender: TObject);
    procedure eAttachIdTChange(Sender: TObject);
    procedure bAttachTransClick(Sender: TObject);
    procedure gStatDblClick(Sender: TObject);
    procedure bStatAClick(Sender: TObject);
    procedure bStatSClick(Sender: TObject);
    procedure bStatTClick(Sender: TObject);
    procedure eStatIdChange(Sender: TObject);
  private
  public
  end;

type
  THackGrid = class(TDBGrid); // to expose protected DataLink property

var
  MainFrm: TMainFrm;

implementation

{$R *.dfm}

uses
  UConnectMdl,
  System.Types, Vcl.Clipbrd;

procedure ChangeHint(C: TControl; Const Hint: String; p: TPoint);
var
  OldHint: String;
begin
  OldHint := C.Hint;
  if Hint <> OldHint then
  begin
    C.Hint := Hint;
    Application.ActivateHint(p);
  end;
end;

procedure TMainFrm.bAttachTransClick(Sender: TObject);
begin
  if ConnectMdl.qTrans.IsEmpty then Exit;

  ConnectMdl.qAttach.Locate('MON$ATTACHMENT_ID', ConnectMdl.qTransMONATTACHMENT_ID.AsInteger, []);
  pcPages.ActivePage := tsAttachments;
end;

procedure TMainFrm.bConnectClick(Sender: TObject);
begin
  if ConnectMdl.dbDB.Connected then
  begin
    ConnectMdl.Disconnect;
    bConnect.Caption := 'Connect';
    bRefresh.Enabled := False;
  end
  else
  begin
    ConnectMdl.Connect(eServer.Text, eDataBase.Text, eUser.Text, ePass.Text);
    bConnect.Caption := 'Disconnect';
    bRefresh.Enabled := True;
    cbOnlyActiveAtt.Checked := True; cbOnlyActiveAttClick(nil);
    cbOnlyActiveSta.Checked := True; cbOnlyActiveStaClick(nil);
    eAttachId.Text := '-1';
    eAttachIdT.Text := '-1';
  end;
end;

procedure TMainFrm.bRefreshClick(Sender: TObject);
begin
  ConnectMdl.RefreshInfo;
end;

procedure TMainFrm.bShowStatementsClick(Sender: TObject);
begin
  if not ConnectMdl.qAttach.IsEmpty then
    eAttachId.Text := ConnectMdl.qAttachMONATTACHMENT_ID.AsString
  else eAttachId.Text := '';
  pcPages.ActivePage := tsStatements;
end;

procedure TMainFrm.bShowTransacClick(Sender: TObject);
begin
  if not ConnectMdl.qAttach.IsEmpty then
    eAttachIdT.Text := ConnectMdl.qAttachMONATTACHMENT_ID.AsString
  else eAttachIdT.Text := '';
  pcPages.ActivePage := tsTransac;
end;

procedure TMainFrm.bStatAClick(Sender: TObject);
begin
  if not ConnectMdl.qAttach.IsEmpty then
    eStatId.Text := ConnectMdl.qAttachMONSTAT_ID.AsString
  else eStatId.Text := '';
  pcPages.ActivePage := tsStats;
end;

procedure TMainFrm.bStatSClick(Sender: TObject);
begin
  if not ConnectMdl.qStatem.IsEmpty then
    eStatId.Text := ConnectMdl.qStatemMONSTAT_ID.AsString
  else eStatId.Text := '';
  pcPages.ActivePage := tsStats;
end;

procedure TMainFrm.bStatTClick(Sender: TObject);
begin
  if not ConnectMdl.qTrans.IsEmpty then
    eStatId.Text := ConnectMdl.qTransMONSTAT_ID.AsString
  else eStatId.Text := '';
  pcPages.ActivePage := tsStats;
end;

procedure TMainFrm.bAttachStaClick(Sender: TObject);
begin
  if ConnectMdl.qStatem.IsEmpty then Exit;

  ConnectMdl.qAttach.Locate('MON$ATTACHMENT_ID', ConnectMdl.qStatemMONATTACHMENT_ID.AsInteger, []);
  pcPages.ActivePage := tsAttachments;
end;

procedure TMainFrm.cbOnlyActiveAttClick(Sender: TObject);
begin
  ConnectMdl.OnlyActiveAtt := cbOnlyActiveAtt.Checked;
end;

procedure TMainFrm.cbOnlyActiveStaClick(Sender: TObject);
begin
  ConnectMdl.OnlyActiveStatem := cbOnlyActiveSta.Checked;
end;

procedure TMainFrm.gAttachmentsMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Cell: TGridCoord;
  ActRec: Integer;
begin
  Cell := TDBGrid(Sender).MouseCoord(X, Y);
  if dgIndicator in TDBGrid(Sender).Options then
    Dec(Cell.X);
  if dgTitles in TDBGrid(Sender).Options then
    Dec(Cell.Y);
  if THackGrid(gStat).DataLink.Active and (Cell.X >= 0) and (Cell.Y >= 0) then
  begin
    ActRec := THackGrid(TDBGrid(Sender)).DataLink.ActiveRecord;
    try
      THackGrid(TDBGrid(Sender)).DataLink.ActiveRecord := Cell.Y;
      if TDBGrid(Sender).Columns[Cell.X].Field.FieldName = 'MON$REMOTE_PROCESS' then
        ChangeHint(TDBGrid(Sender), ConnectMdl.qAttachMONREMOTE_PROCESS.AsString, TDBGrid(Sender).ClientToScreen(Point(X, Y)))
      else
        ChangeHint(TDBGrid(Sender), '', TDBGrid(Sender).ClientToScreen(Point(X, Y)));
    finally
      THackGrid(TDBGrid(Sender)).DataLink.ActiveRecord := ActRec;
    end;
  end;
end;

procedure TMainFrm.gStatDblClick(Sender: TObject);
begin
  Clipboard.AsText := gStat.DataSource.DataSet.FieldByName('sql').AsString;
  ShowMessage('SQL copied to the clipboard');
end;

procedure TMainFrm.gStatMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Cell: TGridCoord;
  ActRec: Integer;
begin
  Cell := gStat.MouseCoord(X, Y);
  if dgIndicator in gStat.Options then
    Dec(Cell.X);
  if dgTitles in gStat.Options then
    Dec(Cell.Y);
  if THackGrid(gStat).DataLink.Active and (Cell.X >= 0) and (Cell.Y >= 0) then
  begin
    ActRec := THackGrid(gStat).DataLink.ActiveRecord;
    try
      THackGrid(gStat).DataLink.ActiveRecord := Cell.Y;
      if gStat.Columns[Cell.X].Field.FieldName = 'SQL' then
        ChangeHint(TDBGrid(Sender), ConnectMdl.qStatemMONSQL_TEXT.AsString, TDBGrid(Sender).ClientToScreen(Point(X, Y)))
      else
        ChangeHint(TDBGrid(Sender), '', TDBGrid(Sender).ClientToScreen(Point(X, Y)));
    finally
      THackGrid(gStat).DataLink.ActiveRecord := ActRec;
    end;
  end;
end;

procedure TMainFrm.eAttachIdChange(Sender: TObject);
var
  Tmp: Integer;
begin
  if (eAttachId.Text <> '') and TryStrToInt(eAttachId.Text, Tmp) then
    ConnectMdl.Attachm := Tmp
  else
    ConnectMdl.Attachm := -1;
end;

procedure TMainFrm.eAttachIdTChange(Sender: TObject);
var
  Tmp: Integer;
begin
  if (eAttachIdT.Text <> '') and TryStrToInt(eAttachIdT.Text, Tmp) then
    ConnectMdl.Transac := Tmp
  else
    ConnectMdl.Transac := -1;
end;

procedure TMainFrm.eStatIdChange(Sender: TObject);
var
  Tmp: Integer;
begin
  if (eStatId.Text <> '') and TryStrToInt(eStatId.Text, Tmp) then
    ConnectMdl.StatId := Tmp
  else
    ConnectMdl.StatId := -1;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  pcPages.ActivePageIndex := 0;
end;

procedure TMainFrm.FormResize(Sender: TObject);
var
  i: Integer;
  Sum: Integer;
begin
  Sum := 0;
  for i := 0 to gStat.Columns.Count - 1 do
    Sum := Sum + gStat.Columns[i].Width;
  Sum := Sum - gStat.Columns[6].Width;
  gStat.Columns[6].Width := gStat.Width - Sum - 50;
end;

end.
